moFillTypeAmountPriceOutput = {};
source(MultiOverlayV4.modDir.."scripte/module/onlyOutputs/moFillTypeAmountPriceConfig.lua");
moFillTypeAmountPriceOutput.isViewBestPrice = false; --for running modul sellingStations

--needs module,moFillTypes,moAmounts,moSellingStations
function moFillTypeAmountPriceOutput:load(cmdTable, slotTable)
	local foundViewBestPrice = false;
	local cmdRegName = cmdTable.regName;	
	local lineTable = {line={}};
	local txtBold = moFillTypeAmountPriceConfig.values.txtBold;
	if moFillTypes ~= nil and moFillTypes.values ~= nil and moFillTypes.values.fillTypes ~= nil then 
		for a=1, #moFillTypes.values.fillTypes do
			if moFillTypes.values.fillTypes[a] ~= nil and (moFillTypes.values.fillTypes[a].view or moFillTypeAmountPriceConfig.values.viewAllFillTypes) then				
				local fillType = moFillTypes.values.fillTypes[a].index;
				local width = {40,30,30};
				if (moFillTypeAmountPriceConfig.values.viewPrices and not moFillTypeAmountPriceConfig.values.viewAmounts) or (not moFillTypeAmountPriceConfig.values.viewPrices and moFillTypeAmountPriceConfig.values.viewAmounts) then
					width = {60,40};
				end;				
				local isAmount = moFillTypes.values.amount[fillType] ~= nil and moFillTypes.values.amount[fillType] > 0;
				local isPrice = moFillTypes.values.bestPrice[fillType] ~= nil and moFillTypes.values.bestPrice[fillType][1] ~= nil and moFillTypes.values.bestPrice[fillType][1][1] > 0;
				if isAmount or (not isAmount and moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount) then
					local nextTxt = 1;					
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[nextTxt] = {};
					local name = "";
					if moFillTypes.values.name then name = moFillTypes.values.fillTypes[a].name;end;
					if moFillTypes.values.regName then
						if string.len(name) == 0 then name = moFillTypes.values.fillTypes[a].regName;else name = name.. " (".. moFillTypes.values.fillTypes[a].regName.. ")";end;
					end;
					if moFillTypes.values.index then
						if string.len(name) == 0 then name = moFillTypes.values.fillTypes[a].index;else name = name.. " *".. moFillTypes.values.fillTypes[a].index.. "*";end;
					end;
					isLineTable.txt[nextTxt].sortByName = tostring(name);
					isLineTable.txt[nextTxt].sortByAmount = 0;
					isLineTable.txt[nextTxt].sortByPrice = 0;
					isLineTable.txt[nextTxt].txt = tostring(name);
					isLineTable.txt[nextTxt].bold = txtBold;
					if isAmount then
						isLineTable.txt[nextTxt].outputColor = "txtFillTypesColor"; 
						isLineTable.txt[nextTxt].isAmount = true;
					else
						isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
						isLineTable.txt[nextTxt].isAmount = false;
					end;
					if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
					isLineTable.txt[nextTxt].width = width[1];				
					nextTxt = nextTxt+1;					
					if moFillTypeAmountPriceConfig.values.viewAmounts then						
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].width = width[nextTxt];
						
						isLineTable.txt[nextTxt].bold = txtBold;
						if isAmount then
							isLineTable.txt[nextTxt].outputColor = "txtAmountColor"; 							
							isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatVolume(math.max(moFillTypes.values.amount[fillType], 0))); --string.format("%1.0f", "".. tostring(moFillTypes.values.amount[fillType]));
							isLineTable.txt[1].sortByAmount = moFillTypes.values.amount[fillType];
						else
							isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
							isLineTable.txt[nextTxt].txt = "-";
							isLineTable.txt[1].sortByAmount = 0;
						end;
						if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].alignment = 3;						
						nextTxt = nextTxt+1;
					end;					
					if moFillTypeAmountPriceConfig.values.viewPrices then						
						local priceTrend = "priceNormal";
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].bold = txtBold;
						if isPrice then							
							foundViewBestPrice = true;
							isLineTable.txt[nextTxt].outputColor = "txtPriceColor";							
							isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatMoney(moFillTypes.values.bestPrice[fillType][1][1], 0, true, false));
							isLineTable.txt[1].sortByPrice = moFillTypes.values.bestPrice[fillType][1][1];
							if moFillTypes.values.bestPrice[fillType][1][3] == "up" then priceTrend = "priceUp";elseif moFillTypes.values.bestPrice[fillType][1][3] == "down" then priceTrend = "priceDown";end;
							isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickOutputPrice;
							isLineTable.txt[nextTxt].ownTable = {fillType, tostring(name)};
						else
							isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
							isLineTable.txt[nextTxt].txt = "-";
							isLineTable.txt[1].sortByPrice = 0;
							priceTrend = nil;
						end;						
						if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].alignment = 3;						
						if moFillTypeAmountPriceConfig.values.viewPriceTrend and priceTrend ~= nil then
							isLineTable.txt[nextTxt].icon = {before={},after={}};
							isLineTable.txt[nextTxt].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
						end;
					end;
				end;
			end;
		end;
		if moFillTypeAmountPriceConfig.values.sortBy ~= 4 then --4 no sort
			function sortByName(w1,w2)		
				if w1.txt[1].sortByName < w2.txt[1].sortByName then
					return true;
				end;				
			end;
			function sortByAmount(w1,w2)		
				if w1.txt[1].sortByAmount > w2.txt[1].sortByAmount then
					return true;
				end;				
			end;
			function sortByPrice(w1,w2)		
				if w1.txt[1].sortByPrice > w2.txt[1].sortByPrice then
					return true;
				end;				
			end;
			if moFillTypeAmountPriceConfig.values.sortBy == 1 then 
				table.sort(lineTable.line, sortByName);
			elseif moFillTypeAmountPriceConfig.values.sortBy == 2 then
				table.sort(lineTable.line, sortByPrice);
			elseif moFillTypeAmountPriceConfig.values.sortBy == 3 then
				table.sort(lineTable.line, sortByAmount);
			end;
		end;
	end;
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = "FillType/Amount/Price";	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickTitleHelpTxt}};
	end;
	if g_currentMission.hl.isMouseCursor then
		local color = "darkGray"
		if moFillTypeAmountPriceConfig.values.viewSettingLines then color = "green";end;
		if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
		isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="outputSetting", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewSettingLines}, infoTxt="Settings"};
	end;
	--setting lines---
	if moFillTypeAmountPriceConfig.values.viewSettingLines then
		local moreTxt = "Name";
		if moFillTypeAmountPriceConfig.values.sortBy == 2 then moreTxt = "Price";elseif moFillTypeAmountPriceConfig.values.sortBy == 3 then moreTxt = "Amount";elseif moFillTypeAmountPriceConfig.values.sortBy == 4 then moreTxt = "NoSort";end;
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].callback = moFillTypeAmountPriceOutput.clickButtonSortBy;
		isLineTable.txt[1].bold = true;		
		isLineTable.txt[1].txt = "Sort by *".. moreTxt.. "*";
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonLeft", color="green", settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickButtonSortBy}};
		
		table.insert(lineTable.line, 3, {});
		isLineTable = lineTable.line[3];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		local color = "green"
		if not moFillTypeAmountPriceConfig.values.viewPrices then color="darkGray";end;
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="pricesOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewPrices"}, infoTxt="View Prices List"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewPriceTrend then color="darkGray";end;
		isLineTable.txt[1].icon.before[2] = {name="priceTrendOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewPriceTrend"}, infoTxt="View PriceTrend"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewAmounts then color="darkGray";end;
		isLineTable.txt[1].icon.before[3] = {name="amountsOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewAmounts"}, infoTxt="View Amounts List"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount then color="darkGray";end;
		isLineTable.txt[1].icon.before[4] = {name="fillTypeNoAmountOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewFillTypeNoAmount"}, infoTxt="View No Amount FillTypes"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewAllFillTypes then color="darkGray";end;
		isLineTable.txt[1].icon.before[5] = {name="viewAllFillTypesOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewAllFillTypes"}, infoTxt="Ignore View On/Off FillTypes"};
		---seperator---
		table.insert(lineTable.line, 4, {});
		isLineTable = lineTable.line[4];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "--";
		isLineTable.txt[2] = {};
		isLineTable.txt[2].slotColor = "txtOutputTitle";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = "--";
		isLineTable.txt[2].alignment = 3;
		---seperator---	
	end;
	--setting lines---
	if foundViewBestPrice then moFillTypeAmountPriceOutput.isViewBestPrice = true;else moFillTypeAmountPriceOutput.isViewBestPrice = false;end; --for running modul sellingStations
	moFillTypeAmountPriceOutput[cmdRegName] = {output=lineTable};
end;

function moFillTypeAmountPriceOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="amounts" } );
	if moFillTypeAmountPriceOutput.isViewBestPrice then moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="sellingStations" } );end;	
	moFillTypeAmountPriceOutput:load(args.cmdTable, args.slotTable);	
	return moFillTypeAmountPriceOutput[args.cmdTable.regName].output;
end;

function moFillTypeAmountPriceOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "FillType/Amount/Price Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Setting Icon/FillType Name/Amount/Price for more Info or ...";
	end;
end;

function moFillTypeAmountPriceOutput.clickViewSettingLines(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moFillTypeAmountPriceConfig.values.viewSettingLines = not moFillTypeAmountPriceConfig.values.viewSettingLines;
	end;
end;

function moFillTypeAmountPriceOutput.clickButtonSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if moFillTypeAmountPriceConfig.values.sortBy+1 > moFillTypeAmountPriceConfig.values.maxSortBy then moFillTypeAmountPriceConfig.values.sortBy = 1;else moFillTypeAmountPriceConfig.values.sortBy = moFillTypeAmountPriceConfig.values.sortBy+1;end;		
	end;
end;

function moFillTypeAmountPriceOutput.clickViewOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] == "viewPrices"	then
			moFillTypeAmountPriceConfig.values.viewPrices = not moFillTypeAmountPriceConfig.values.viewPrices;
			if not moFillTypeAmountPriceConfig.values.viewPrices then moFillTypeAmountPriceConfig.values.viewPriceTrend = false;end;
		elseif args.ownTable[1] == "viewAmounts" then
			moFillTypeAmountPriceConfig.values.viewAmounts = not moFillTypeAmountPriceConfig.values.viewAmounts;
		elseif args.ownTable[1] == "viewPriceTrend"	and moFillTypeAmountPriceConfig.values.viewPrices then
			moFillTypeAmountPriceConfig.values.viewPriceTrend = not moFillTypeAmountPriceConfig.values.viewPriceTrend;
		elseif args.ownTable[1] == "viewFillTypeNoAmount" then
			moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount = not moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount;
		elseif args.ownTable[1] == "viewAllFillTypes" then
			moFillTypeAmountPriceConfig.values.viewAllFillTypes = not moFillTypeAmountPriceConfig.values.viewAllFillTypes;
		end;
	end;
end;

function moFillTypeAmountPriceOutput.clickOutputPrice(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and moFillTypes.values.bestPrice[args.ownTable[1]] ~= nil then
			local fillTypes = moFillTypes.values.bestPrice[args.ownTable[1]];
			local bestPriceStation1 = "";
			local bestPriceStation2 = "";
			local bestPriceStation3 = "";
			local bestPriceStation4 = "";
			if fillTypes[1] ~= nil then
				bestPriceStation1 = Utils.getNoNil(fillTypes[1][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[1][1], 0, true, false), "Unknown");				
				if Utils.getNoNil(fillTypes[1][3], "Unknown") == "up" then 				
					bestPriceStation1 = bestPriceStation1.. " (UP)";
				elseif Utils.getNoNil(fillTypes[1][3], "Unknown") == "down" then 
					bestPriceStation1 = bestPriceStation1.. " (DOWN)";
				else
					bestPriceStation1 = bestPriceStation1.. " (-)";
				end;
				--if string.find(bestPriceStation1, "Unknown") then bestPriceStation1 = "";end;
			end;
			if fillTypes[2] ~= nil then
				bestPriceStation2 = Utils.getNoNil(fillTypes[2][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[2][1], 0, true, false), "Unknown");	
				if Utils.getNoNil(fillTypes[2][3], "Unknown") == "up" then 				
					bestPriceStation2 = bestPriceStation2.. " (UP)";
				elseif Utils.getNoNil(fillTypes[2][3], "Unknown") == "down" then 
					bestPriceStation2 = bestPriceStation2.. " (DOWN)";
				else
					bestPriceStation2 = bestPriceStation2.. " (-)";
				end;
				--if string.find(bestPriceStation2, "Unknown") then bestPriceStation2 = "";end;
			end;
			if fillTypes[3] ~= nil then
				bestPriceStation3 = Utils.getNoNil(fillTypes[3][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[3][1], 0, true, false), "Unknown");	
				if Utils.getNoNil(fillTypes[3][3], "Unknown") == "up" then 				
					bestPriceStation3 = bestPriceStation3.. " (UP)";
				elseif Utils.getNoNil(fillTypes[3][3], "Unknown") == "down" then 
					bestPriceStation3 = bestPriceStation3.. " (DOWN)";
				else
					bestPriceStation3 = bestPriceStation3.. " (-)";
				end;
				--if string.find(bestPriceStation3, "Unknown") then bestPriceStation3 = "";end;
			end;
			if fillTypes[4] ~= nil then
				bestPriceStation4 = Utils.getNoNil(fillTypes[4][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[4][1], 0, true, false), "Unknown");	
				if Utils.getNoNil(fillTypes[4][3], "Unknown") == "up" then 				
					bestPriceStation4 = bestPriceStation4 .. " (UP)";
				elseif Utils.getNoNil(fillTypes[4][3], "Unknown") == "down" then 
					bestPriceStation4 = bestPriceStation4.. " (DOWN)";
				else
					bestPriceStation4 = bestPriceStation4.. " (-)";
				end;
				--if string.find(bestPriceStation4, "Unknown") then bestPriceStation4 = "";end;
			end;
			if string.len(bestPriceStation1) > 0 then
				moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.help.titel = "Best Price Stations:  *".. tostring(args.ownTable[2]).. "*";
				moSetGetOverlays.infoHelpBox.help.txt = tostring(bestPriceStation1).. "\n".. tostring(bestPriceStation2).. "\n".. tostring(bestPriceStation3).. "\n".. tostring(bestPriceStation4);
			end;
		end;
	end;
end;


