moWtmSetting = {}

function moWtmSetting:clickButtonCallback(args)
	local color = "";
	local txt = "";
	if args.lineButton.ownTable.side == 1 then
		if args.lineButton.ownTable.whatClick == "ls22WeatherOnOff_" then			
			moSetGet:setWtmState("ShowWeather", not moSetGet:getWtmState("ShowWeather"));			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		elseif args.lineButton.ownTable.whatClick == "ls22TemperatureOnOff_" then			
			moSetGet:setWtmState("ShowTemperature", not moSetGet:getWtmState("ShowTemperature"));			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;	
		elseif args.lineButton.ownTable.whatClick == "ls22IngameDateOnOff_" then			
			if g_currentMission.hud.gameInfoDisplay.showDate then
				moSetGet:setWtmState("ShowIngameDate", false);
			else
				moSetGet:setWtmState("ShowIngameDate", true);		
			end;
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		elseif args.lineButton.ownTable.whatClick == "ls22IngameTimeOnOff_" then			
			if g_currentMission.hud.gameInfoDisplay.showTime then
				moSetGet:setWtmState("ShowIngameTime", false);
			else
				moSetGet:setWtmState("ShowIngameTime", true);		
			end;
			g_currentMission.hlGui.setGet:setUnSave();			
			return;	
		elseif args.lineButton.ownTable.whatClick == "ls22MoneyOnOff_" then			
			if g_currentMission.hud.gameInfoDisplay.showMoney then
				moSetGet:setWtmState("ShowMoney", false);
			else
				moSetGet:setWtmState("ShowMoney", true);	
			end;
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		elseif args.lineButton.ownTable.whatClick == "generateMohWtmPda_" then			
			if moSetGetOverlays.pda["weatherTimeMoneyPda_"] ~= nil then return;end;
			moAutoGeneratePda:generatePda("weatherTimeMoneyPda", true, nil);
			return;		
		elseif args.lineButton.ownTable.whatClick == "mohWtmBackground_" then			
			moGeneralSettings.wtm.mohWtmBackground = not moGeneralSettings.wtm.mohWtmBackground;
			g_currentMission.hlGui.setGet:setUnSave();			
			return;	
		end;
	end;
end;

function moWtmSetting:txtButtonCallback(lineButton)
	local txtButton = "";
	if lineButton.ownTable.side == 1 then
		if lineButton.ownTable.whatClick == "ls22WeatherOnOff_" then
			if moSetGet:getWtmState("ShowWeather") then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;
		elseif lineButton.ownTable.whatClick == "ls22TemperatureOnOff_" then
			if moSetGet:getWtmState("ShowTemperature") then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;	
		elseif lineButton.ownTable.whatClick == "ls22IngameDateOnOff_" then
			if moSetGet:getWtmState("ShowIngameDate") then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;
		elseif lineButton.ownTable.whatClick == "ls22IngameTimeOnOff_" then
			if moSetGet:getWtmState("ShowIngameTime") then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;	
		elseif lineButton.ownTable.whatClick == "ls22MoneyOnOff_" then
			if moSetGet:getWtmState("ShowMoney") then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;
		elseif lineButton.ownTable.whatClick == "generateMohWtmPda_" then				
				if moSetGetOverlays.pda["weatherTimeMoneyPda_"] ~= nil then
					txtButton = "Pda already exists"
					lineButton.clickButtonColor = "red";
				else
					txtButton = "Ready"
					lineButton.clickButtonColor = "green";
				end;				
		elseif lineButton.ownTable.whatClick == "mohWtmBackground_" then
			if moGeneralSettings.wtm.mohWtmBackground then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;	
		end;
	end;
	return txtButton;
end;

function moWtmSetting:pullDownCallback(lineButton)
	local pullDownTable = {}
	if lineButton.ownTable.side == 1 then
		
		function comp(w1,w2)			
			if w1.txt < w2.txt then
				return true;
			end;			
		end;	
		if #pullDownTable > 0 then table.sort(pullDownTable, comp);end;
	end;
	return pullDownTable;
end;

function moWtmSetting:clickPullDownLineCallback(args)
	
end;

function moWtmSetting:generateSide(side)
	local buttons = {};
	local color = ""
	local txtButton = "";
	if side == 1 then
		--line--
		buttons = {
			[1] = {
				txtOverButton = "Show LS Weather";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="ls22WeatherOnOff_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die LS22 Wetter Anzeige";				
			};
			[2] = {
				txtOverButton = "Show LS Temperature";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="ls22TemperatureOnOff_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die LS22 Temperatur Anzeige";				
			};
			[3] = {
				txtOverButton = "Show LS Date";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="ls22IngameDateOnOff_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die LS22 Tages Anzeige";				
			};
			[4] = {
				txtOverButton = "Show LS Time";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="ls22IngameTimeOnOff_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die LS22 Uhrzeit Anzeige";				
			};
			[5] = {
				txtOverButton = "Show LS Money";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="ls22MoneyOnOff_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die LS22 Geld Anzeige";				
			};			
		};		
		g_currentMission.hlGui.setGet:generateModSideLine({modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["WtmSetting"], side=side, lineButtons=buttons});
		--line--
		--line--
		g_currentMission.hlGui.setGet:generateModSideLine({modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["WtmSetting"], side=side}); --empty
		--line--
		--line--
		buttons = {
			[1] = {
				txtOverButton = "Generate Moh Wtm Pda";				
				txtButton = "Ready";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonGenerate";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="generateMohWtmPda_",side=side};
				txtInfo = "Generiert ein eigenes WTM Pda(Auto Disable LS22 WTM Hud). Das Pda kann von euch auch angepasst werden.";
			};
			[2] = {
				visible = false;								
				width = 40;
			};
			[3] = {
				txtOverButton = "Show Moh Wtm Background";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="WtmSetting", whatClick="mohWtmBackground_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere den Wetter Hintergrund von den eigenen Wetter Icons,wenn diese gesetzt wurden.";	
				width = 30;
			};
		};	
		g_currentMission.hlGui.setGet:generateModSideLine({modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["WtmSetting"], side=side, lineButtons=buttons});
		--line--
	end;
end;
























